/**
 * MyPoint2D
 * rappresenta un punto nel piano cartesiano
 *
 * @author Adriano Luchetta
 * @version 25-10-2007
 *
 */
 
public class MyPoint2D
{
   //variabili di esemplare
   private double x;
   private double y;
   
   /**
      inizializza l'ascissa e l'ordinata del punto
      @param aX ascissa
      @param aY ordinata
   */
   public MyPoint2D(double aX, double aY)
   {
      x = aX;
      y = aY;
   }
   
   /**
      calcola la distanza fra due punti
      
      @param q punto per il calcolo della distanza
      @return distanza fra due punti     
   */
   public double distance(MyPoint2D q)
   {
      double dquadro = (x - q.x) * (x - q.x) + (y - q.y) * (y - q.y);
      return Math.sqrt(dquadro);
   }
   
   /**
      calcola il punto medio fra due punti
      @param q punto per il calcolo del punto medio
      @return punto medio 
   */ 
   public MyPoint2D mediumPoint(MyPoint2D q)
   {
      double xm = (x + q.x) / 2;
      double ym = (y + q.y) / 2;
      
      MyPoint2D tmp = new MyPoint2D(xm, ym);
      
      return tmp;
   }
   
   /**
      descrizione testuale nella forma (x, y)
      @return descrizione testuale
   */ 
   public String toString()
   {
      return "(" + x + ", " + y + ")";
   }         
}
