/**
 * TriangularNumberGenerator
 * Invia a standard output i primi n numeri triangolari.
 * Il numero n e' acquisito da standard input.
 *
 * @author Adriano Luchetta
 * @version 16-Ott-2005
 */

   /* Numeri triangolari
      I numeri trangolari sono generati dalla successione
      t(n) = n * (n + 1) / 2, per n >= 1
                                                    *
                                        *          * *
                              *        * *        * * *
                      *      * *      * * *      * * * *
                *    * *    * * *    * * * *    * * * * *
            *  * *  * * *  * * * *  * * * * *  * * * * * *
      
      t(n)  1   3     6      10        15          21
      n     1   2     3       4         5           6
   */

import java.util.Scanner;

public class TriangularNumberGenerator
{
   public static void main(String[] args)
   {
      final int CARATTERI_PER_NUMERO = 10;
      final int NUMERO_COLONNE = 5;

      Scanner in = new Scanner(System.in);

      System.out.println("**************************************************");
      System.out.println("*** GENERAZIONE DEI PRIMI N NUMERI TRIANGOLARI ***");
      System.out.println("**************************************************");
      System.out.println("");

      System.out.print("N?: ");
      int n = in.nextInt();

      // gestione caso non ammesso n <= 0
      if (n <= 0)
      {
         System.out.println(n + ": ingresso non ammesso");
         return;
      }
      
      // Generazione dei primi n numeri triangolari
      for (int k = 1; k < n + 1; k++)
      {
      	 String fString = (k * (k + 1) / 2) + "";
      	 while (fString.length() < CARATTERI_PER_NUMERO)
            fString = " " + fString;

         String separatore = " ";
         if (k % NUMERO_COLONNE == 0)
            separatore = "\n";
            
         System.out.print(fString + separatore);
      }
      
      System.out.println();
      // chiude il flusso
      in.close();
   }
}
